#!/usr/bin/env python

import sys, getopt, time, pyosd, os
import pygtk,wnck
import pyatspi
pygtk.require('2.0')
import gtk, gobject
import LtMacroAPI
from ctypes import *


#              1,2,3,4,5,6,7   
assoc_buttons=[5,1,3,4,2,5,1]
assoc_direct =[1,0,0,0,1,0,1]


class extWin:
	def __init__(self):
		self.screen = wnck.screen_get_default()
		while gtk.events_pending():
			gtk.main_iteration()
		for window in self.screen.get_windows():
			if not window.get_name().startswith('A Tale'):
				continue
		self.gdkDisplay = gtk.gdk.Display(None)
		self.wnckWin = window
		self.xid    = window.get_xid()
		self.gdkWin = gtk.gdk.window_foreign_new(self.xid)
		self.init_osd()
		self.init_coreX()

	def init_coreX(self):
		self.Xlib = CDLL("libX11.so.6")
		self.Xtst = CDLL("libXtst.so.6")
		self.dpy = self.Xtst.XOpenDisplay(None)
		self.Xlib.XFlush(self.dpy)

	def init_osd(self):
		self.osd = pyosd.osd()
		self.osd.set_font("-adobe-helvetica-bold-r-normal-*-*-100-*-*-p-*-*");
		self.osd.set_colour("lawngreen");
		self.osd.set_vertical_offset(48);
		self.osd.set_align(pyosd.ALIGN_RIGHT)

	def beep(self):
		self.gdkDisplay.beep()
		self.gdkDisplay.sync()

	def focus(self):
		while gtk.events_pending():
			gtk.main_iteration()
		self.wnckWin.activate(gtk.get_current_event_time())
		self.gdkDisplay.sync()

	def osdlog(self,msg):
		self.osd.display(msg)
	
	def get_coords(self):
		display = self.gdkWin.get_screen().get_display()
		cursor = gtk.gdk.Cursor(display, gtk.gdk.CROSSHAIR)
		#  gtk.gdk.pointer_grab(window, owner_events=False, event_mask=0, confine_to=None, cursor=None, time=0L)
		if (gtk.gdk.pointer_grab(self.gdkWin, False,
				gtk.gdk.BUTTON_RELEASE_MASK, None, cursor) == gtk.gdk.GRAB_SUCCESS):
			Clicked = False
			while Clicked == False:
				(screen,root_x,root_y,mods) = display.get_pointer()
				if mods & gtk.gdk.BUTTON1_MASK :
					Clicked = True
			gtk.gdk.pointer_ungrab()
			display.flush()
			(absX,absY) = self.gdkWin.get_origin()
			return (root_x, root_y, root_x-absX, root_y-absY)
		else:
			self.osdlog("Faild to grab mouse")
			return (0,0,0,0)

	def fake_key(self):
		#event = gtk.gdk.Event(gtk.gdk.KEY_PRESS)
		#event.keyval = gtk.keysyms.a
		#event.state = gtk.gdk.SHIFT_MASK
		#event.window = win.get_root_window()
		event.put()

	def send_string(self,s):
		for ch in s:
			keyval = gtk.gdk.unicode_to_keyval(ord(ch))
			pyatspi.Registry.generateKeyboardEvent(keyval, None, pyatspi.KEY_SYM)


class Base:
	def __init__(self):
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.set_decorated(False)
		self.window.set_title("Easy Crematory!")
		self.window.set_keep_above(True)
		color = gtk.gdk.color_parse('#234fdb')
		self.window.modify_bg(gtk.STATE_NORMAL, color)

		self.window.connect("destroy", self.destroy)
		self.box1 = gtk.HBox(False, 0)
		self.window.add(self.box1)
		
		i = 1
		self.buttons = []
		self.accel_group = gtk.AccelGroup()
		for assoc in assoc_buttons:
			b = gtk.ToggleButton()
			dir = assoc_direct[i-1]
			id = b.connect("toggled", self.toggle_button_callback)
			self.box1.pack_start(b, True, True, 0)
			b.set_data("user_data", [id,assoc,dir])
			self.set_btn_image(b)
			b.show()
			i = i + 1
			self.buttons.append(b)
		self.box1.show()
		self.window.set_app_paintable(True)
		self.window.show()

	def set_btn_image(self,button):
		b_data = button.get_data("user_data")[1]
		b_dir  = button.get_data("user_data")[2]
		if button.get_active():
			# button is pressed
			b_dir = not b_dir
		if b_dir:
			letter = "u"
		else:
			letter = "d" 
		image = gtk.Image()
		image.set_from_file("./gfx/go-"+letter+str(b_data)+".png")
		image.show()
		button.set_image(image)

	def toggle_button_callback(self,button):
		press_button  = button.get_data("user_data")[1]
		for b in self.buttons:
			b_data = b.get_data("user_data")[1]
			if b_data == press_button :
				b_id   =  b.get_data("user_data")[0]
				b.handler_block(b_id)
				b.set_active(button.get_active())
				self.set_btn_image(b)
				b.handler_unblock(b_id)
		atitd.osdlog("I press crematory button :"+str(press_button))	
		LtMacroAPI.clickwindow(hits[press_button-1])

	def main(self):
		gtk.main()

	def destroy(self, widget, data=None):
		print "destroy signal occurred"
		gtk.main_quit()

if __name__ == "__main__":
	gtk.gdk.set_show_events(True)
	hits = []
	atitd = extWin()
	atitd.focus()
	#atitd.send_string("Talos")

	print "Crematory made easy by Talos."
	print "------------------------------"
	print "* Click on crematory buttons now"
	for i in range(5):
		print "Get button :",str(i+1)
		atitd.osdlog("Get button :"+str(i+1))
		(target_hit, root_hit) = LtMacroAPI.getwindowclick()
		hits.append(target_hit)
		atitd.beep()
	print "* Good. Now use Alt+mouse to move the new UI window"	
	base = Base()
	base.main()

